local Utils = GetLibResearchUtils()
local API = GetLibResearchAPIWrapper()
local MKC = GetLibResearchMotifKnowledgeContainer()

function RB2.Commands.handler( arg )
	RB2.Debug.info("Command handler invoked!")

	if (arg == "show") then
		RB2.UI.ToggleController()
	elseif (arg == "lock") then
		local cd = RB2.SettingsObject:getCurrentCharacterData()
		RB2.UI.Controls.MainPanel:SetMovable(cd.Locked)
		RB2.UI.Controls.PanelResearch:SetMovable(cd.Locked)
		RB2.UI.Controls.PanelKnowledge:SetMovable(cd.Locked)
		cd.Locked = not cd.Locked
		if (cd.Locked) then
			RB2.chatOutput(RB2.Colors.Yellow .. "Main panel is now locked.")
		else
			RB2.chatOutput(RB2.Colors.Yellow .. "Main panel is now unlocked.")
		end
--	elseif (arg == "dwemer") then
--		local bits = MKC:getDwemerChapterBits()
--		RB2.chatOutput(RB2.Colors.Yellow .. "Dwemer bits: " .. bits)
--		RB2.chatOutput(RB2.Colors.Teal .. "Please post the above number together with the list of your character's "
--			.. "known dwemer chapters on the addon's Comments page. Thank you!")		
	elseif (arg == "d") then
		RB2.Commands.debug()
	else
		RB2.Commands.printHelp()
	end
end

function RB2.Commands.printHelp()
	RB2.chatOutput(RB2.Colors.BrightGreen .. RB2.AddonConfig.AddonName .. " v" .. RB2.AddonConfig.AddonVersion)
	RB2.chatOutput(" ")
	RB2.chatOutput(RB2.Colors.Yellow .. "Commands")
	RB2.chatOutput(RB2.Colors.Orange .. "    /rb2" .. RB2.Colors.White .."                - Prints help")
	RB2.chatOutput(RB2.Colors.Orange .. "    /rb2 show" .. RB2.Colors.White .."      - Toggles visibility of the main panel")
	RB2.chatOutput(RB2.Colors.Orange .. "    /rb2 lock" .. RB2.Colors.White .."        - Toggles the locked state of the main panel")
--	RB2.chatOutput(RB2.Colors.Orange .. "    /rb2 dwemer" .. RB2.Colors.White .." - Provides extremely useful information related to Dwemer motifs")
end

function RB2.Commands.debug()
end
