RB2 = {}

RB2.LibRes = LibStub:GetLibrary("LibResearch")
if not RB2.LibRes then return end

RB2.AddonConfig = {
	AddonID = "ResearchBuddy2",
	AddonName = "Research Buddy 2",
	AddonAbbrev = "RB2",
	AddonPrefix = "RB2",
	Author = "Thifi",
	AddonVersion = "2.1.7",
	SavedVariablesVersion = 4,
	SettingsPanelID = "RB2Settings",
	SettingsPanelName = "|cF5AD05Research Buddy 2|r",
	GetTradingHouseSearchResultItemLinkWorkaround = true,
}

RB2.DefaultSettings = {}
RB2.Name = RB2.AddonConfig.AddonID
RB2.DisplayName = RB2.AddonConfig.SettingsPanelName
RB2.Version = RB2.AddonConfig.AddonVersion

RB2.Colors = {
	BrightBlue  = "|c0000FF",
	White       = "|cFFFFFF",
	Yellow      = "|cFFFF00",
	BrightGreen = "|c00FF00",
	Teal        = "|c00FFFF",
	DarkRed     = "|c990000",
	BrightRed   = "|cFF0000",
	Orange      = "|cF5AD05",
}

RB2.InventoryFunctionIdentifier = "ZO_Inventory_SetupSlot"
RB2.InventoryFunctionEnabled = true
RB2.TradingHouseTabSwitchIdentifier = "HandleTabSwitch"
RB2.TradingDisabledTabs = { 
	[2] = 1,
	[3] = 1,
} 
RB2.InventoryGridViewEnabled = false
RB2.DisableInventoryRefresh = false

RB2.Debug = GetLibResearchDebug()
RB2.API = GetLibResearchAPIWrapper()

RB2.Buffers = {
	["RB2_" .. EVENT_LOOT_RECEIVED] = 0.5,
	["RB2_" .. EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS] = 0.5,
	["RB2_" .. EVENT_INVENTORY_SINGLE_SLOT_UPDATE] = 0.5,
	["RB2_" .. EVENT_INVENTORY_ITEM_DESTROYED] = 0.5,
	["RB2_" .. EVENT_SMITHING_TRAIT_RESEARCH_STARTED] = 0.5,
	["RB2_" .. EVENT_SMITHING_TRAIT_RESEARCH_COMPLETED] = 0.5,
	["RB2_" .. EVENT_CRAFT_COMPLETED] = 0.5,
}

RB2.Commands = {}

RB2.Icons = {
	"/esoui/art/icons/servicemappins/servicepin_smithy.dds",
	"/esoui/art/icons/servicemappins/servicepin_woodworking.dds",
	"/esoui/art/icons/servicemappins/servicepin_outfitter.dds",
}

RB2.Knowledge = {
	KnowledgeTables = {
		{
			{ "", "", "1_1_1", "1_2_1", "1_3_1", "1_4_1", "1_5_1", "1_6_1", "1_7_1", "", "6_1_1", "6_2_1", "6_3_1", "6_4_1", "6_5_1", "" },
			{ "", "", "1_1_2", "1_2_2", "1_3_2", "1_4_2", "1_5_2", "1_6_2", "1_7_2", "", "6_1_2", "6_2_2", "6_3_2", "6_4_2", "6_5_2", "" },
			{ "", "", "1_1_3", "1_2_3", "1_3_3", "1_4_3", "1_5_3", "1_6_3", "1_7_3", "", "6_1_3", "6_2_3", "6_3_3", "6_4_3", "6_5_3", "" },
			{ "", "", "1_1_4", "1_2_4", "1_3_4", "1_4_4", "1_5_4", "1_6_4", "1_7_4", "", "6_1_4", "6_2_4", "6_3_4", "6_4_4", "6_5_4", "" },
			{ "", "", "1_1_5", "1_2_5", "1_3_5", "1_4_5", "1_5_5", "1_6_5", "1_7_5", "", "6_1_5", "6_2_5", "6_3_5", "6_4_5", "6_5_5", "" },
			{ "", "", "1_1_6", "1_2_6", "1_3_6", "1_4_6", "1_5_6", "1_6_6", "1_7_6", "", "6_1_6", "6_2_6", "6_3_6", "6_4_6", "6_5_6", "" },
			{ "", "", "1_1_7", "1_2_7", "1_3_7", "1_4_7", "1_5_7", "1_6_7", "1_7_7", "", "6_1_7", "6_2_7", "6_3_7", "6_4_7", "6_5_7", "" },
			{ "", "", "1_1_8", "1_2_8", "1_3_8", "1_4_8", "1_5_8", "1_6_8", "1_7_8", "", "6_1_8", "6_2_8", "6_3_8", "6_4_8", "6_5_8", "" },
			{ "", "", "1_1_9", "1_2_9", "1_3_9", "1_4_9", "1_5_9", "1_6_9", "1_7_9", "", "6_1_9", "6_2_9", "6_3_9", "6_4_9", "6_5_9", "" },
		},
		{
			{ "", "", "2_1_1", "2_2_1", "2_3_1", "2_4_1", "2_5_1", "2_6_1", "2_7_1", "", "2_8_1", "2_9_1", "2_10_1", "2_11_1", "2_12_1", "2_13_1", "2_14_1", "", "1_8_1", "1_9_1", "1_10_1", "1_11_1", "1_12_1", "1_13_1", "1_14_1", "", "6_6_1", "" },
			{ "", "", "2_1_2", "2_2_2", "2_3_2", "2_4_2", "2_5_2", "2_6_2", "2_7_2", "", "2_8_2", "2_9_2", "2_10_2", "2_11_2", "2_12_2", "2_13_2", "2_14_2", "", "1_8_2", "1_9_2", "1_10_2", "1_11_2", "1_12_2", "1_13_2", "1_14_2", "", "6_6_2", "" },
			{ "", "", "2_1_3", "2_2_3", "2_3_3", "2_4_3", "2_5_3", "2_6_3", "2_7_3", "", "2_8_3", "2_9_3", "2_10_3", "2_11_3", "2_12_3", "2_13_3", "2_14_3", "", "1_8_3", "1_9_3", "1_10_3", "1_11_3", "1_12_3", "1_13_3", "1_14_3", "", "6_6_3", "" },
			{ "", "", "2_1_4", "2_2_4", "2_3_4", "2_4_4", "2_5_4", "2_6_4", "2_7_4", "", "2_8_4", "2_9_4", "2_10_4", "2_11_4", "2_12_4", "2_13_4", "2_14_4", "", "1_8_4", "1_9_4", "1_10_4", "1_11_4", "1_12_4", "1_13_4", "1_14_4", "", "6_6_4", "" },
			{ "", "", "2_1_5", "2_2_5", "2_3_5", "2_4_5", "2_5_5", "2_6_5", "2_7_5", "", "2_8_5", "2_9_5", "2_10_5", "2_11_5", "2_12_5", "2_13_5", "2_14_5", "", "1_8_5", "1_9_5", "1_10_5", "1_11_5", "1_12_5", "1_13_5", "1_14_5", "", "6_6_5", "" },
			{ "", "", "2_1_6", "2_2_6", "2_3_6", "2_4_6", "2_5_6", "2_6_6", "2_7_6", "", "2_8_6", "2_9_6", "2_10_6", "2_11_6", "2_12_6", "2_13_6", "2_14_6", "", "1_8_6", "1_9_6", "1_10_6", "1_11_6", "1_12_6", "1_13_6", "1_14_6", "", "6_6_6", "" },
			{ "", "", "2_1_7", "2_2_7", "2_3_7", "2_4_7", "2_5_7", "2_6_7", "2_7_7", "", "2_8_7", "2_9_7", "2_10_7", "2_11_7", "2_12_7", "2_13_7", "2_14_7", "", "1_8_7", "1_9_7", "1_10_7", "1_11_7", "1_12_7", "1_13_7", "1_14_7", "", "6_6_7", "" },
			{ "", "", "2_1_8", "2_2_8", "2_3_8", "2_4_8", "2_5_8", "2_6_8", "2_7_8", "", "2_8_8", "2_9_8", "2_10_8", "2_11_8", "2_12_8", "2_13_8", "2_14_8", "", "1_8_8", "1_9_8", "1_10_8", "1_11_8", "1_12_8", "1_13_8", "1_14_8", "", "6_6_8", "" },
			{ "", "", "2_1_9", "2_2_9", "2_3_9", "2_4_9", "2_5_9", "2_6_9", "2_7_9", "", "2_8_9", "2_9_9", "2_10_9", "2_11_9", "2_12_9", "2_13_9", "2_14_9", "", "1_8_9", "1_9_9", "1_10_9", "1_11_9", "1_12_9", "1_13_9", "1_14_9", "", "6_6_9", "" },
		},
	},
	TableHeaders = { {}, {} },
	ColumnWidths = {
		{ 125, 16, 24, 24, 24, 24, 24, 24, 24, 16, 24, 24, 24, 24, 24, 16, },
		{ 125, 16, 24, 24, 24, 24, 24, 24, 24, 16, 24, 24, 24, 24, 24, 24, 24, 16, 24, 24, 24, 24, 24, 24, 24, 16, 24, 16, },
	},
	ColumnTypes = {
		{ "C", "D", "I", "I", "I", "I", "I", "I", "I", "D", "I", "I", "I", "I", "I", "D", },
		{ "C", "D", "I", "I", "I", "I", "I", "I", "I", "D", "I", "I", "I", "I", "I", "I", "I", "D", "I", "I", "I", "I", "I", "I", "I", "D", "I", "D", },
	},
	ColumnHeaders = {
		{ nil, nil, nil, nil, nil, "Smithing", nil, nil, nil, nil, nil, nil, "Woodworking", nil, nil, nil, },
		{ nil, nil, nil, nil, nil, "Light", nil, nil, nil, nil, nil, nil, nil, "Medium", nil, nil, nil, nil, nil, nil, nil, "Heavy", nil, nil, nil, nil, "SH", nil, },
	},
	RowHeight = 24,
	IconColumnWidth = 24,
	DividerColumnWidth = 16,
	IconWidth = 20,
	IconHeight = 20,
	DividerWidth = 2,
	GridSpacing = 10,
	
	MotifsPerRow = 4,
	MotifWidth = 48,
	MotifHeight = 48,
	MotifXPadding = 20,
	MotifYPadding = 2,
	MotifIDs = {
		["16424"] = { 8 }, -- The High Elves
		["27245"] = { 5 }, -- The Dark Elves
		["16428"] = { 9 }, -- The Wood Elves
		["27244"] = { 6 }, -- The Nords
		["16425"] = { 2 }, -- The Bretons
		["16427"] = { 3 }, -- The Redguards
		["44698"] = { 10 }, -- The Khajiit
		["16426"] = { 4 }, -- The Orcs
		["27246"] = { 7 }, -- The Argonians
		["54868"] = { 35 }, -- The Imperials
		["51638"] = { 16 }, -- Ancient Elves
		["51565"] = { 18 }, -- Barbaric
		["51345"] = { 20 }, -- Primal
		["51688"] = { 21 }, -- Daedric
		["57573"] = { 15, 10 }, -- Dwemer Axes,		10 
		["57574"] = { 15, 6 },  -- Dwemer Belts,	6
		["57575"] = { 15, 3 },  -- Dwemer Boots,	3
		["57576"] = { 15, 14 }, -- Dwemer Bows,		14
		["57577"] = { 15, 5 },  -- Dwemer Chests,	5
		["57578"] = { 15, 11 }, -- Dwemer Daggers,	11 
		["57579"] = { 15, 2 },  -- Dwemer Gloves,	2 
		["57580"] = { 15, 1 },  -- Dwemer Helmets,	1 
		["57581"] = { 15, 4 },  -- Dwemer Legs,		4 
		["57582"] = { 15, 9 },  -- Dwemer Maces,	9 
		["57583"] = { 15, 13 }, -- Dwemer Shields,	13
		["57584"] = { 15, 7 },  -- Dwemer Shoulders,7
		["57585"] = { 15, 12 }, -- Dwemer Staves,	12
		["57586"] = { 15, 8 },  -- Dwemer Swords,	8 
	}
}

RB2.Knowledge.Grids = { }
