
local APIWrapper = {}

function APIWrapper.GetNumSmithingResearchLines(tradeSkillType)
	-- Returns: integer numLines
	return GetNumSmithingResearchLines(tradeSkillType)
end

function APIWrapper.GetSmithingResearchLineInfo(tradeSkillType, researchLineIndex)
	-- Returns: string name, textureName icon, integer numTraits, integer timeRequiredForNextResearchSecs
	return GetSmithingResearchLineInfo(tradeSkillType, researchLineIndex)
end

function APIWrapper.GetSmithingResearchLineTraitInfo(tradeSkillType, researchLineIndex, traitIndex)
	-- Returns: ItemTraitType traitType, string traitDescription, bool known
	return GetSmithingResearchLineTraitInfo(tradeSkillType, researchLineIndex, traitIndex)
end

function APIWrapper.GetSmithingResearchLineTraitTimes(tradeSkillType, researchLineIndex, traitIndex)
	-- Returns: integer:nilable duration, integer:nilable timeRemainingSecs
	return GetSmithingResearchLineTraitTimes(tradeSkillType, researchLineIndex, traitIndex)
end

function APIWrapper.CanItemBeSmithingTraitResearched(bagId, slotIndex, tradeSkillType, researchLineIndex, traitIndex)
	-- Returns: bool canBeResearched
	return CanItemBeSmithingTraitResearched(bagId, slotIndex, tradeSkillType, researchLineIndex, traitIndex);
end

function APIWrapper.IsItemJunk(bagId, slotIndex)
	-- Returns: bool junk
	return IsItemJunk(bagId, slotIndex)
end

function APIWrapper.GetItemTraitTypeName(itemTraitType)
	local traitTypeNameKey = "SI_ITEMTRAITTYPE" .. itemTraitType
	local traitTypeName = APIWrapper.GetString(_G[traitTypeNameKey])

	return traitTypeName
end

function APIWrapper.GetItemStyleName(itemStyle)
	local itemStyleKey = "SI_ITEMSTYLE" .. itemStyle
	local itemStyleName = APIWrapper.GetString(_G[itemStyleKey])

	return itemStyleName
end

function APIWrapper.GetMaxSimultaneousSmithingResearch(tradeSkillType)
	-- Returns: integer numLines
	return GetMaxSimultaneousSmithingResearch(tradeSkillType)
end

function APIWrapper.GetSmithingResearchLineTraitTimes(tradeSkillType, researchLineIndex, traitIndex)
	-- Returns: integer:nilable duration, integer:nilable timeRemainingSecs
	return GetSmithingResearchLineTraitTimes(tradeSkillType, researchLineIndex, traitIndex)
end

function APIWrapper.GetString(id)
	return GetString(id)
end

function APIWrapper.GetTimeStamp()
	-- Returns: id64 timestamp
	return GetTimeStamp()
end

function APIWrapper.GetCharacterName()
	return GetUnitName("player")
end

function APIWrapper.IsPlayerDead()
	return IsUnitDead("player") 
end

function APIWrapper.IsPlayerInCombat()
	return IsUnitInCombat("player")
end

function APIWrapper.IsPlayerBeingArrested()
	return IsUnderArrest()
end

function APIWrapper.GetTradingHouseSearchResultItemLink(itemIndex, linkStyle)
	return GetTradingHouseSearchResultItemLink(itemIndex, linkStyle)
end

function APIWrapper.GetTradingHouseSearchResultItemLinkBrackets(itemIndex)
	return GetTradingHouseSearchResultItemLink(itemIndex, LINK_STYLE_BRACKETS)
end

function APIWrapper.GetItemTotalCount(bagId, slotIndex)
	-- Returns: integer count
	return GetItemTotalCount(bagId, slotIndex)
end

function APIWrapper.GetBagSize(bagId)
	return GetBagSize(bagId)
end

function APIWrapper.GetItemLink(bagId, slotIndex, linkStyle)
	return GetItemLink(bagId, slotIndex, linkStyle)
end

function APIWrapper.GetItemLinkBrackets(bagId, slotIndex)
	return GetItemLink(bagId, slotIndex, LINK_STYLE_BRACKETS)
end

function APIWrapper.GetItemLinkItemType(itemLink)
	return GetItemLinkItemType(itemLink)
end

function APIWrapper.GetItemLinkEquipType(itemLink)
	return GetItemLinkEquipType(itemLink)
end

function APIWrapper.GetItemLinkArmorType(itemLink)
	return GetItemLinkArmorType(itemLink)
end

function APIWrapper.GetItemLinkWeaponType(itemLink)
	return GetItemLinkWeaponType(itemLink)
end

function APIWrapper.GetItemLinkTraitInfo(itemLink)
	return GetItemLinkTraitInfo(itemLink)
end

function APIWrapper.GetNumSmithingStyleItems()
	return GetNumSmithingStyleItems()
end

function APIWrapper.GetSmithingStyleItemInfo(styleItemIndex)
	-- Returns: string itemName, textureName icon, integer sellPrice, bool meetsUsageRequirement, integer itemStyle, integer quality
	return GetSmithingStyleItemInfo(styleItemIndex)
end

function APIWrapper.IsSmithingStyleKnown(styleItemIndex)
	return IsSmithingStyleKnown(styleItemIndex)
end

function APIWrapper.GetSmithingStyleItemLink(styleItemIndex)
	return GetSmithingStyleItemLink(styleItemIndex)
end

function APIWrapper.GetItemLinkItemType(itemLink)
	return GetItemLinkItemType(itemLink)
end

function APIWrapper.GetItemLinkBookTitle(itemLink)
	return GetItemLinkBookTitle(itemLink)
end

function APIWrapper.IsItemLinkBookKnown(itemLink)
	return IsItemLinkBookKnown(itemLink)
end

function APIWrapper.GetAchievementLink(id)
	return GetAchievementLink(id)
end

function APIWrapper.ParseLink(link)
	return { ZO_LinkHandler_ParseLink(link) }
end

function APIWrapper.GetLootItemLink(lootId)
	return GetLootItemLink(lootId, LINK_STYLE_BRACKETS)
end

function GetLibResearchAPIWrapper()
	return APIWrapper
end
