local API = GetLibResearchAPIWrapper()
local Utils = GetLibResearchUtils()

local MotifRefData = { }

function MotifRefData:new(styleItemIndex)
	local obj = {}
	setmetatable(obj, self)
	self.__index = self
	obj.StyleItemIndex = styleItemIndex
	obj.Name = nil
	obj.Icon = nil
	obj.ItemStyleID = 0
--	obj.Known = false
	obj.StyleItemLink = nil
	obj.StyleName = nil
	obj.Valid = false

	obj:enrich()

	return obj;
end

function MotifRefData:enrich()
	local name, icon, sellPrice, meets, itemStyle, quality = API.GetSmithingStyleItemInfo(self.StyleItemIndex)
	if ((name ~= nil) and (name ~= "")) then
		self.Valid = true
		self.Name = Utils.prettifyItemName(name)
		self.Icon = icon
		self.ItemStyleID = itemStyle
	
		self.StyleItemLink = API.GetSmithingStyleItemLink(self.StyleItemIndex)
		self.StyleName = Utils.prettifyItemName(RB2.API.GetItemStyleName(self.ItemStyleID))
	end
end

function MotifRefData:equals(otherMotifRefData)
	local result = true
	if (otherMotifRefData == nil) then
		return false
	end

	for key, value in pairs(self) do
		if (value ~= otherMotifRefData[key]) then
			result = false
			break
		end
	end

	return result
end

function GetLibResearchMotifRefData()
	return MotifRefData
end
