local API = GetLibResearchAPIWrapper()
local debug = GetLibResearchDebug()
local MD = GetLibResearchMotifRefData()

local MotifRefDataContainer = { }

function MotifRefDataContainer:new()
	local obj = {}
	setmetatable(obj, self)
	self.__index = self

	obj.MotifRefDataTable = {}

	local styleNums = API.GetNumSmithingStyleItems()
	for i = 1, styleNums do
		local md = MD:new(i)
		if (md.Valid) then
			obj.MotifRefDataTable[md.StyleItemIndex] = md
		end
	end

	return obj;
end

function MotifRefDataContainer:getMotifRefDataByKey(stlyeItemIndex)
	return self.MotifRefDataTable[stlyeItemIndex]
end

function MotifRefDataContainer:getMotifRefDataTable()
	return self.MotifRefDataTable
end

function GetLibResearchMotifRefDataContainer()
	return MotifRefDataContainer
end
