local logCat = "ResearchRefDataContainer"
local API = GetLibResearchAPIWrapper()
--local debug = GetLibResearchDebug()
local config = GetLibResearchConfig()
local resRefData = GetLibResearchResearchRefData()

local ResearchRefDataContainer = { }

function ResearchRefDataContainer:new()
	local obj = {}
	setmetatable(obj, self)
	self.__index = self

	obj.RefDataTable = {}
	obj.RefDataKeyTable = {}

	for tradeSkillType, tsID, tsName in config.tradeSkillTraverse(config.TradeSkillTypes) do
		--		debug.debug(string.format("Type: %d, ID: %s, Name: %s", tradeSkillType, tsID, tsName))
		local numLines = API.GetNumSmithingResearchLines(tradeSkillType)
		for researchLineIndex = 1, numLines do
			local _, _, numTraits, _ = API.GetSmithingResearchLineInfo(tradeSkillType, researchLineIndex)
			for traitIndex = 1, numTraits do
				--				debug.debug(string.format("Key: %d_%d_%d", tradeSkillType, researchLineIndex, traitIndex))
				local rrd = resRefData:new(tradeSkillType, researchLineIndex, traitIndex)
				--				debug.debug(rrd:toString(), logCat)
				table.insert(obj.RefDataTable, rrd)
				obj.RefDataKeyTable[rrd:getKey()] = rrd
			end
		end
	end

	return obj;
end

function ResearchRefDataContainer:getResearchRefDataByKey(researchKey)
	return self.RefDataKeyTable[researchKey]
end

function ResearchRefDataContainer:getMaxSimultaneousSmithingResearch(tradeSkillType)
	return self.MaxResearchesTable[tradeSkillType]
end

function GetLibResearchResearchRefDataContainer()
	return ResearchRefDataContainer
end
